#   begin_generated_IBM_prolog
#
#   prolog.pro.samp.telcosp
#   ******************************************************************
#   IBM Sample Source Materials
#
#   Sample source materials are supplied As-Is.
#   No warranty is expressed or implied.
#
#   Product(s): 5724-O05 soa
#
#   (C)Copyright IBM Corp. 2000, 2006
#
#   The source code for this program supplied under the terms of the
#   End User License Agreement (EULA) that accompanied this product.
#   ******************************************************************
#
#   end_generated_IBM_prolog

import sys.argv
import getopt
from com.ibm.twss.spm.admin.common import ScopedPolicy
from com.ibm.twss.spm.admin.common import PolicyValue

from pytwss.mbean import spm_mbean, mbean_utils
from pytwss.utils import _, log

def main(**kwargs):
	req_scope = 'ALL'
	if kwargs.has_key('req_scope'):
		req_scope = kwargs['req_scope']
	svc_scope = 'ALL'
	if kwargs.has_key('svc_scope'):
		svc_scope = kwargs['svc_scope']
	op_scope = 'ALL'
	if kwargs.has_key('op_scope'):
		op_scope = kwargs['op_scope']

	policy_admin = spm_mbean.PolicyAdministration()

	policies = [
		ScopedPolicy(
			requesterIdentifier=req_scope,
			serviceIdentifier=svc_scope,
			operation=op_scope,
			name='message.UseUTCTime',
			value=PolicyValue(
				value='true',
				type='Boolean'
			)
		),
            ScopedPolicy(
			requesterIdentifier=req_scope,
			serviceIdentifier=svc_scope,
			operation=op_scope,
			name='message.transaction.RecordTransaction',
			value=PolicyValue(
				value='false',
				type='Boolean'
			)
		),
		ScopedPolicy(
			requesterIdentifier=req_scope,
			serviceIdentifier=svc_scope,
			operation=op_scope,
			name='message.statistics.RecordStatistics',
			value=PolicyValue(
				value='false',
				type='Boolean'
			)
		),
            ScopedPolicy(
			requesterIdentifier=req_scope,
			serviceIdentifier=svc_scope,
			operation=op_scope,
			name='message.cei.Enabled',
			value=PolicyValue(
				value='false',
				type='Boolean'
			)
		),
		ScopedPolicy(
			requesterIdentifier=req_scope,
			serviceIdentifier=svc_scope,
			operation=op_scope,
			name='message.LoggingEnabled',
			value=PolicyValue(
				value='false',
				type='Boolean'
			)
		),
		ScopedPolicy(
			requesterIdentifier=req_scope,
			serviceIdentifier=svc_scope,
			operation=op_scope,
			name='message.groups.MaxGroupSize',
			value=PolicyValue(
				value='100',
				type='Numeric'
			)
		),
        # Cluster SLA defaults
        ScopedPolicy(
			requesterIdentifier=req_scope,
			serviceIdentifier=svc_scope,
			operation=op_scope,
			name='message.sla.ClusterEnabled',
			value=PolicyValue(
				value='false',
				type='Boolean'
			)
		),
		ScopedPolicy(
			requesterIdentifier=req_scope,
			serviceIdentifier=svc_scope,
			operation=op_scope,
			name='message.sla.ClusterWeight',
			value=PolicyValue(
				value='0',
				type='Numeric'
			)
		),
		ScopedPolicy(
			requesterIdentifier=req_scope,
			serviceIdentifier=svc_scope,
			operation=op_scope,
			name='message.sla.ClusterRequesterRate',
			value=PolicyValue(
				value='0',
				type='Numeric'
			)
		),
		ScopedPolicy(
			requesterIdentifier=req_scope,
			serviceIdentifier=svc_scope,
			operation=op_scope,
			name='message.sla.ClusterServiceRate',
			value=PolicyValue(
				value='0',
				type='Numeric'
			)
		),
		ScopedPolicy(
			requesterIdentifier=req_scope,
			serviceIdentifier=svc_scope,
			operation=op_scope,
			name='message.sla.ClusterOperationRate',
			value=PolicyValue(
				value='0',
				type='Numeric'
			)
		),
		# Local SLA defaults
        ScopedPolicy(
			requesterIdentifier=req_scope,
			serviceIdentifier=svc_scope,
			operation=op_scope,
			name='message.sla.LocalEnabled',
			value=PolicyValue(
				value='false',
				type='Boolean'
			)
		),
		ScopedPolicy(
			requesterIdentifier=req_scope,
			serviceIdentifier=svc_scope,
			operation=op_scope,
			name='message.sla.LocalWeight',
			value=PolicyValue(
				value='0',
				type='Numeric'
			)
		),
		ScopedPolicy(
			requesterIdentifier=req_scope,
			serviceIdentifier=svc_scope,
			operation=op_scope,
			name='message.sla.LocalRequesterRate',
			value=PolicyValue(
				value='0',
				type='Numeric'
			)
		),
		ScopedPolicy(
			requesterIdentifier=req_scope,
			serviceIdentifier=svc_scope,
			operation=op_scope,
			name='message.sla.LocalServiceRate',
			value=PolicyValue(
				value='0',
				type='Numeric'
			)
		),
		ScopedPolicy(
			requesterIdentifier=req_scope,
			serviceIdentifier=svc_scope,
			operation=op_scope,
			name='message.sla.LocalOperationRate',
			value=PolicyValue(
				value='0',
				type='Numeric'
			)
		),
	]
	spm_mbean.createPolicies(policy_admin, policies)

def parseOpts(args):
	opts = { }
	try:
		pairs, args = getopt.getopt(args, '', [
			'req_scope=', # Explicit requester scope
			'svc_scope=', # Explicit service scope
			'op_scope=',  # Explicit operation scope
		])
		for opt, val in pairs:
			if opt[:2] == '--':
				opt = opt[2:]
			opts[opt] = val
	except getopt.GetoptError:
		pass
	return opts

# Execute if we're the main script
if __name__ == 'main':
	opts = parseOpts(sys.argv)
	if opts:
		log(_("SOAC7522I"))
		for key in opts.keys():
			log(_("SOAC7523I") %{ 'opt' : key, 'arg' : opts[key] })
	main(**opts)
